<!doctype html>
<html lang="en">
<head>
    <title>Code coverage report for contracts/Staking.sol</title>
    <meta charset="utf-8" />
    <link rel="stylesheet" href="../prettify.css" />
    <link rel="stylesheet" href="../base.css" />
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <style type='text/css'>
        .coverage-summary .sorter {
            background-image: url(../sort-arrow-sprite.png);
        }
    </style>
</head>
<body>
<div class='wrapper'>
  <div class='pad1'>
    <h1>
      <a href="../index.html">all files</a> / <a href="index.html">contracts/</a> Staking.sol
    </h1>
    <div class='clearfix'>
      <div class='fl pad1y space-right2'>
        <span class="strong">100% </span>
        <span class="quiet">Statements</span>
        <span class='fraction'>183/183</span>
      </div>
      <div class='fl pad1y space-right2'>
        <span class="strong">100% </span>
        <span class="quiet">Branches</span>
        <span class='fraction'>190/190</span>
      </div>
      <div class='fl pad1y space-right2'>
        <span class="strong">100% </span>
        <span class="quiet">Functions</span>
        <span class='fraction'>38/38</span>
      </div>
      <div class='fl pad1y space-right2'>
        <span class="strong">100% </span>
        <span class="quiet">Lines</span>
        <span class='fraction'>240/240</span>
      </div>
    </div>
  </div>
  <div class='status-line high'></div>
<pre><table class="coverage">
<tr><td class="line-count quiet">1
2
3
4
5
6
7
8
9
10
11
12
13
14
15
16
17
18
19
20
21
22
23
24
25
26
27
28
29
30
31
32
33
34
35
36
37
38
39
40
41
42
43
44
45
46
47
48
49
50
51
52
53
54
55
56
57
58
59
60
61
62
63
64
65
66
67
68
69
70
71
72
73
74
75
76
77
78
79
80
81
82
83
84
85
86
87
88
89
90
91
92
93
94
95
96
97
98
99
100
101
102
103
104
105
106
107
108
109
110
111
112
113
114
115
116
117
118
119
120
121
122
123
124
125
126
127
128
129
130
131
132
133
134
135
136
137
138
139
140
141
142
143
144
145
146
147
148
149
150
151
152
153
154
155
156
157
158
159
160
161
162
163
164
165
166
167
168
169
170
171
172
173
174
175
176
177
178
179
180
181
182
183
184
185
186
187
188
189
190
191
192
193
194
195
196
197
198
199
200
201
202
203
204
205
206
207
208
209
210
211
212
213
214
215
216
217
218
219
220
221
222
223
224
225
226
227
228
229
230
231
232
233
234
235
236
237
238
239
240
241
242
243
244
245
246
247
248
249
250
251
252
253
254
255
256
257
258
259
260
261
262
263
264
265
266
267
268
269
270
271
272
273
274
275
276
277
278
279
280
281
282
283
284
285
286
287
288
289
290
291
292
293
294
295
296
297
298
299
300
301
302
303
304
305
306
307
308
309
310
311
312
313
314
315
316
317
318
319
320
321
322
323
324
325
326
327
328
329
330
331
332
333
334
335
336
337
338
339
340
341
342
343
344
345
346
347
348
349
350
351
352
353
354
355
356
357
358
359
360
361
362
363
364
365
366
367
368
369
370
371
372
373
374
375
376
377
378
379
380
381
382
383
384
385
386
387
388
389
390
391
392
393
394
395
396
397
398
399
400
401
402
403
404
405
406
407
408
409
410
411
412
413
414
415
416
417
418
419
420
421
422
423
424
425
426
427
428
429
430
431
432
433
434
435
436
437
438
439
440
441
442
443
444
445
446
447
448
449
450
451
452
453
454
455
456
457
458
459
460
461
462
463
464
465
466
467
468
469
470
471
472
473
474
475
476
477
478
479
480
481
482
483
484
485
486
487
488
489
490
491
492
493
494
495
496
497
498
499
500
501
502
503
504
505
506
507
508
509
510
511
512
513
514
515
516
517
518
519
520
521
522
523
524
525
526
527
528
529
530
531
532
533
534
535
536
537
538
539
540
541
542
543
544
545
546
547
548
549
550
551
552
553
554
555
556
557
558
559
560
561
562
563
564
565
566
567
568
569
570
571
572
573
574
575
576
577
578
579
580
581
582
583
584
585
586
587
588
589
590
591
592
593
594
595
596
597
598
599
600
601
602
603
604
605
606
607
608
609
610
611
612
613
614
615
616
617
618
619
620
621
622
623
624
625
626
627
628
629
630
631
632
633
634
635
636
637
638
639
640
641
642
643
644
645
646
647
648
649
650
651
652
653
654
655
656
657
658
659
660
661
662
663
664
665
666
667
668
669
670
671
672
673
674
675
676
677
678
679
680
681
682
683
684
685
686
687
688
689
690
691
692
693
694
695
696
697
698
699
700
701
702
703
704
705
706
707
708
709
710
711
712
713
714
715
716
717
718
719
720
721
722
723
724
725
726
727
728
729
730
731
732
733
734
735
736
737
738
739
740
741
742
743
744
745
746
747
748
749
750
751
752
753
754
755
756
757
758
759
760
761
762
763
764
765
766
767
768
769
770
771
772
773
774
775
776
777
778
779
780
781
782
783
784
785
786
787
788
789
790
791
792
793
794
795
796
797
798
799
800
801
802
803
804
805
806
807
808
809
810
811
812
813
814
815
816
817
818
819
820
821
822
823
824
825
826
827
828
829
830
831
832
833
834
835
836
837
838
839
840
841
842
843
844
845
846
847
848
849
850
851
852
853
854
855</td><td class="line-coverage quiet"><span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-yes">289×</span>
<span class="cline-any cline-yes">281×</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-yes">96×</span>
<span class="cline-any cline-yes">92×</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-yes">102×</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-yes">101×</span>
<span class="cline-any cline-yes">100×</span>
<span class="cline-any cline-yes">99×</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-yes">98×</span>
<span class="cline-any cline-yes">98×</span>
<span class="cline-any cline-yes">98×</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-yes">98×</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-yes">3×</span>
<span class="cline-any cline-yes">2×</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-yes">1×</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-yes">1×</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-yes">3×</span>
<span class="cline-any cline-yes">2×</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-yes">1×</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-yes">1×</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-yes">4×</span>
<span class="cline-any cline-yes">3×</span>
<span class="cline-any cline-yes">2×</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-yes">1×</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-yes">1×</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-yes">78×</span>
<span class="cline-any cline-yes">78×</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-yes">103×</span>
<span class="cline-any cline-yes">102×</span>
<span class="cline-any cline-yes">101×</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-yes">100×</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-yes">44×</span>
<span class="cline-any cline-yes">44×</span>
<span class="cline-any cline-yes">44×</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-yes">56×</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-yes">100×</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-yes">100×</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-yes">100×</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-yes">55×</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-yes">55×</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-yes">53×</span>
<span class="cline-any cline-yes">21×</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-yes">53×</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-yes">53×</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-yes">53×</span>
<span class="cline-any cline-yes">37×</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-yes">53×</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-yes">6×</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-yes">6×</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-yes">4×</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-yes">3×</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-yes">3×</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-yes">90×</span>
<span class="cline-any cline-yes">90×</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-yes">2×</span>
<span class="cline-any cline-yes">2×</span>
<span class="cline-any cline-yes">2×</span>
<span class="cline-any cline-yes">1×</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-yes">12×</span>
<span class="cline-any cline-yes">11×</span>
<span class="cline-any cline-yes">10×</span>
<span class="cline-any cline-yes">10×</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-yes">8×</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-yes">8×</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-yes">8×</span>
<span class="cline-any cline-yes">8×</span>
<span class="cline-any cline-yes">8×</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-yes">8×</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-yes">8×</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-yes">8×</span>
<span class="cline-any cline-yes">8×</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-yes">8×</span>
<span class="cline-any cline-yes">8×</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-yes">8×</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-yes">8×</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-yes">8×</span>
<span class="cline-any cline-yes">6×</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-yes">6×</span>
<span class="cline-any cline-yes">5×</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-yes">2×</span>
<span class="cline-any cline-yes">1×</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-yes">2×</span>
<span class="cline-any cline-yes">2×</span>
<span class="cline-any cline-yes">1×</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-yes">6×</span>
<span class="cline-any cline-yes">5×</span>
<span class="cline-any cline-yes">4×</span>
<span class="cline-any cline-yes">3×</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-yes">2×</span>
<span class="cline-any cline-yes">2×</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-yes">1×</span>
<span class="cline-any cline-yes">1×</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-yes">13×</span>
<span class="cline-any cline-yes">12×</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-yes">10×</span>
<span class="cline-any cline-yes">9×</span>
<span class="cline-any cline-yes">8×</span>
<span class="cline-any cline-yes">8×</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-yes">2×</span>
<span class="cline-any cline-yes">1×</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-yes">1×</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-yes">20×</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-yes">19×</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-yes">2×</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-yes">6×</span>
<span class="cline-any cline-yes">5×</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-yes">2×</span>
<span class="cline-any cline-yes">2×</span>
<span class="cline-any cline-yes">6×</span>
<span class="cline-any cline-yes">6×</span>
<span class="cline-any cline-yes">6×</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-yes">6×</span>
<span class="cline-any cline-yes">6×</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-yes">2×</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-yes">5×</span>
<span class="cline-any cline-yes">4×</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-yes">1×</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-yes">1×</span>
<span class="cline-any cline-yes">3×</span>
<span class="cline-any cline-yes">3×</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-yes">3×</span>
<span class="cline-any cline-yes">3×</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-yes">1×</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-yes">5×</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-yes">31×</span>
<span class="cline-any cline-yes">25×</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-yes">25×</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-yes">25×</span>
<span class="cline-any cline-yes">24×</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-yes">25×</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-yes">25×</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-yes">6×</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-yes">3×</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-yes">3×</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-yes">2×</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-yes">4×</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-yes">6×</span>
<span class="cline-any cline-yes">5×</span>
<span class="cline-any cline-yes">4×</span>
<span class="cline-any cline-yes">4×</span>
<span class="cline-any cline-yes">5×</span>
<span class="cline-any cline-yes">5×</span>
<span class="cline-any cline-yes">5×</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-yes">4×</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-yes">2×</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-yes">523×</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-yes">745×</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-yes">479×</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-yes">479×</span>
<span class="cline-any cline-yes">60×</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-yes">419×</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-yes">259×</span>
<span class="cline-any cline-yes">259×</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-yes">208×</span>
<span class="cline-any cline-yes">208×</span>
<span class="cline-any cline-yes">208×</span>
<span class="cline-any cline-yes">208×</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-yes">208×</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-yes">51×</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-yes">130×</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-yes">91×</span>
<span class="cline-any cline-yes">89×</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-yes">88×</span>
<span class="cline-any cline-yes">88×</span>
<span class="cline-any cline-yes">88×</span>
<span class="cline-any cline-yes">88×</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-yes">88×</span>
<span class="cline-any cline-yes">88×</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-yes">58×</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-yes">58×</span>
<span class="cline-any cline-yes">58×</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-yes">88×</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-yes">88×</span>
<span class="cline-any cline-yes">88×</span>
<span class="cline-any cline-yes">88×</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-yes">88×</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-yes">76×</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-yes">76×</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-yes">12×</span>
<span class="cline-any cline-yes">12×</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-yes">12×</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-yes">12×</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-yes">88×</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-yes">88×</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-yes">87×</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-yes">87×</span>
<span class="cline-any cline-yes">87×</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-yes">87×</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-yes">87×</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-yes">87×</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-yes">87×</span>
<span class="cline-any cline-yes">18×</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-yes">18×</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-yes">87×</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-yes">85×</span>
<span class="cline-any cline-yes">85×</span>
<span class="cline-any cline-yes">85×</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-yes">85×</span>
<span class="cline-any cline-yes">17×</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-yes">85×</span>
<span class="cline-any cline-yes">28×</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-yes">85×</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-yes">196×</span>
<span class="cline-any cline-yes">196×</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-yes">196×</span>
<span class="cline-any cline-yes">196×</span>
<span class="cline-any cline-yes">100×</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-yes">196×</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-yes">196×</span>
<span class="cline-any cline-yes">54×</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-yes">196×</span>
<span class="cline-any cline-yes">196×</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-yes">117×</span>
<span class="cline-any cline-yes">117×</span>
<span class="cline-any cline-yes">117×</span>
<span class="cline-any cline-yes">116×</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-yes">115×</span>
<span class="cline-any cline-yes">115×</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-yes">115×</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-yes">115×</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-yes">115×</span>
<span class="cline-any cline-yes">30×</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-yes">115×</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-yes">115×</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-yes">115×</span>
<span class="cline-any cline-yes">115×</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-yes">121×</span>
<span class="cline-any cline-yes">121×</span>
<span class="cline-any cline-yes">120×</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-yes">119×</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-yes">119×</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-yes">40×</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-yes">119×</span>
<span class="cline-any cline-yes">101×</span>
<span class="cline-any cline-yes">101×</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-yes">271×</span>
<span class="cline-any cline-yes">271×</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-yes">271×</span>
<span class="cline-any cline-yes">123×</span>
<span class="cline-any cline-yes">123×</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span></td><td class="text"><pre class="prettyprint lang-js">//SPDX-License-Identifier: MIT
pragma solidity =0.8.18;
&nbsp;
import '@openzeppelin/contracts-upgradeable/access/OwnableUpgradeable.sol';
import '@openzeppelin/contracts-upgradeable/security/PausableUpgradeable.sol';
import '@openzeppelin/contracts-upgradeable/token/ERC20/utils/SafeERC20Upgradeable.sol';
import '@openzeppelin/contracts-upgradeable/utils/structs/EnumerableSetUpgradeable.sol';
&nbsp;
/**
 * @title Staking
 * @author gotbit
 * @notice Contract for staking tokens in order to earn rewards.
 * Any user can make multiple stakes. Reward earn period is practically unlimited.
 * 
 * Contract uses ErrorGuards Pattern
 * 
 * Available to reset when guard is enabled:
 * - staking token
 * - reward token
 * - rewards duration
 * - owner
 * - token amount on contract
 * 
 * Locked write methods when guard is disabled:
 * - notifyRewardAmount
 * - notifyRewardAmountPrevious
 * - finish
 * - stake
 * - withdraw
 * - claim
 * - withdrawOtherTokens
 * - setPaused
 */
&nbsp;
&nbsp;
&nbsp;
contract Staking is OwnableUpgradeable, PausableUpgradeable {
    using SafeERC20Upgradeable for IERC20Upgradeable;
    using EnumerableSetUpgradeable for EnumerableSetUpgradeable.UintSet;
    using EnumerableSetUpgradeable for EnumerableSetUpgradeable.AddressSet;
&nbsp;
    // TYPES
&nbsp;
    struct Stake {
        uint256 id;
        uint256 amount;
        uint256 earned;
        uint256 claimed;
        uint256 userRewardPerTokenPaid;
        address owner;
        uint32 timestamp;
        uint32 unstakedAtBlockNumber;
        uint32 unstakedAtBlockTimestamp;
    }
&nbsp;
    // CONSTANTS
&nbsp;
    uint256 public constant ACCURACY = 1e18;
    uint256 public constant TREASURY_STAKE_AMOUNT = 1; // 1 wei (to simplify calculations)
    uint256 public constant MIN_REWARDS_DURATION = 1 minutes; // 1 min
    uint256 public constant MAX_STAKE = 10 ** 30;
    // reward rate will not fall into overflow
    // even if reward is being added during 1000 min possible reward periods in a row
    uint256 public constant MAX_RATE = type(uint128).max / (1000 * MIN_REWARDS_DURATION);
    uint256 public constant MAX_REWARDS_DURATION = 10 * 365 days; // 10 years (to prevent overflow)
&nbsp;
    // STATE VARIABLES
&nbsp;
    bool public errorGuardDisabled; // true if error guard if off, default - enabled
&nbsp;
    // ------------------ immutables section -----------------
&nbsp;
    IERC20Upgradeable public stakingToken;
    IERC20Upgradeable public rewardToken;
&nbsp;
    // ------------------ immutables section -----------------
&nbsp;
    uint128 public rewardRate;
    uint128 public rewardsRemaining;
&nbsp;
    uint256 public rewardPerTokenStored;
&nbsp;
    uint64 public periodFinish;
&nbsp;
    // rewardsDuration is not  always equal to periodFinish - periodStart
    uint64 public rewardsDuration;
&nbsp;
    uint64 public lastUpdateTime;
&nbsp;
    // variable for correct reward calculations in case  of rewardsDuration changes
    uint64 public periodStart;
&nbsp;
    // sum of all rewards distributed to users in all periods
    uint256 public cumulativeDistributedReward;
    // sum of claimed reawards in one current reward period
    uint256 public currentRewardPaid;
    // sum of claimed reawards in all reward periods
    uint256 public cumulativeRewardPaid;
&nbsp;
    // sum of unused rewards by all users in all owner locks in the current period
    // unused reward is set = 0 in each notify
    uint256 public currentPeriodUnusedRewardsSum;
&nbsp;
    uint256 public unusedRewardsExtracted;
&nbsp;
    mapping(uint256 =&gt; Stake) public stakes;
    mapping(address =&gt; uint256[]) public userInactiveStakes;
    mapping(address =&gt; EnumerableSetUpgradeable.UintSet) private idsByUser;
&nbsp;
    mapping(address =&gt; uint256) public userBalances;
&nbsp;
    uint256 public globalId;
&nbsp;
    // hide real total supply
    uint256 private totalSupplyInternal;
    // number of currenlty active stakes
    uint128 private numOfActiveStakesInternal;
&nbsp;
    // first reward period creation timestamp
    uint128 public firstRewardPeriodStart;
&nbsp;
    // active stake holder
    EnumerableSetUpgradeable.AddressSet private holders;
&nbsp;
    bool public finished;
&nbsp;
    // EVENTS
&nbsp;
    event RewardAdded(uint256 reward);
    event Staked(
        address indexed user,
        uint256 indexed id,
        uint256 amount,
        uint256 totalSupply
    );
    event Withdrawn(
        address indexed user,
        uint256 indexed id,
        uint256 amount,
        uint256 totalSupply
    );
    event RewardPaid(address indexed user, uint256 indexed id, uint256 reward);
    event RewardsDurationUpdated(uint256 indexed newDuration);
    event Finished(address indexed recepient);
    event WithdrawnTokens(address indexed recepient, uint256 indexed amount);
    event ErrorGuardUpdatedStakingToken(address indexed stakingToken);
    event ErrorGuardUpdatedRewardToken(address indexed rewardToken);
    event ErrorGuardPulledTokens(address indexed token, address indexed recepient, uint256 amount);
    event ErrorGuardDisaabled();
&nbsp;
    //  MODIFIERS
&nbsp;
    modifier onlyWhenErrorGuardDisabled() {
        require(errorGuardDisabled, 'Error guard enabled');
        _;
    }
&nbsp;
    modifier onlyWhenErrorGuardEnabled() {
        require(!errorGuardDisabled, 'Error guard disabled');
        _;
    }
&nbsp;
    //  FUNCTIONS
&nbsp;
    constructor() {
        _disableInitializers();
    }
&nbsp;
    // external
&nbsp;
    /// @notice Inits a new contract
    /// @param stakingToken_ staking token address
    /// @param rewardToken_ reward token address
    /// @param owner_ owner address
    function init(
        IERC20Upgradeable stakingToken_,
        IERC20Upgradeable rewardToken_,
        address owner_
    ) external initializer {
        require(address(stakingToken_) != address(0), 'Invalid address');
        require(address(rewardToken_) != address(0), 'Invalid address');
        require(owner_ != address(0), 'Invalid address');
&nbsp;
        stakingToken = stakingToken_;
        rewardToken = rewardToken_;
        rewardsDuration = 365 days;
&nbsp;
        _transferOwnership(owner_);
    }
&nbsp;
    // -------------- error guards ---------------
&nbsp;
    function errorGuardStakingToken(address _stakingToken) external onlyWhenErrorGuardEnabled onlyOwner {
        require(_stakingToken != address(stakingToken), 'Duplicate');
        require(_stakingToken != address(0), 'Invalid token');
&nbsp;
        stakingToken = IERC20Upgradeable(_stakingToken);
&nbsp;
        emit ErrorGuardUpdatedStakingToken(_stakingToken);
    }
&nbsp;
    function errorGuardRewardToken(address _rewardToken) external onlyWhenErrorGuardEnabled onlyOwner {
        require(_rewardToken != address(rewardToken), 'Duplicate');
        require(_rewardToken != address(0), 'Invalid token');
&nbsp;
        rewardToken = IERC20Upgradeable(_rewardToken);
&nbsp;
        emit ErrorGuardUpdatedRewardToken(_rewardToken);
    }
&nbsp;
    function errorGuardPullTokens(
        address token,
        address to,
        uint256 amount
    ) external onlyWhenErrorGuardEnabled onlyOwner {
        require(token != address(0), 'Invalid token');
        require(to != address(0), 'Zero recepient');
        require(amount != 0, 'Zero amount');
&nbsp;
        emit ErrorGuardPulledTokens(token, to, amount);
&nbsp;
        IERC20Upgradeable(token).safeTransfer(to, amount);
    }
&nbsp;
    function disableErrorGuard() external onlyWhenErrorGuardEnabled onlyOwner {
        errorGuardDisabled = true;
        emit ErrorGuardDisaabled();
    }
&nbsp;
    // -------------- error guards ---------------
&nbsp;
    /// @dev Allows user to stake tokens
    /// @param amount of token to stake
    function stake(uint256 amount) external onlyWhenErrorGuardDisabled whenNotPaused {
        require(amount &gt; 0, 'Cannot stake 0');
        require(amount &lt;= MAX_STAKE, 'Stake amount too high');
        require(periodFinish &gt; block.timestamp, 'Reward period not activated');
&nbsp;
        // if no active stakers were previously =&gt; unstake owner stake to stop accumulating unused rewards
        if (totalSupply() == 0) {
            // change stakes[0].earned
            _updateReward(0, true);
            (, uint256 unusedRewards) = _withdrawInternal(0, address(this));
            currentPeriodUnusedRewardsSum += unusedRewards;
        } else {
            // do not change stakes[0]
            _updateReward(0, false);
        }
&nbsp;
        // execute stake
        _stakeInternal(amount, msg.sender);
&nbsp;
        emit Staked(msg.sender, globalId, amount, totalSupply());
&nbsp;
        stakingToken.safeTransferFrom(msg.sender, address(this), amount);
    }
&nbsp;
    /// @dev Allows user to withdraw staked tokens + claim earned rewards
    /// @param id Stake id
    function withdraw(uint256 id) external onlyWhenErrorGuardDisabled {
        _updateReward(id, true);
        // CHANGE STATE &amp; EXECUTE ALL CHECKS
        (uint256 amount, uint256 reward) = _withdrawInternal(id, msg.sender);
&nbsp;
        // if no active stakers left =&gt; create a owner stake to accumulate unused rewards
        if (totalSupply() == 0) {
            _stakeInternal(TREASURY_STAKE_AMOUNT, address(this));
        }
&nbsp;
        emit Withdrawn(msg.sender, id, amount, totalSupply());
&nbsp;
        // ALL TOKENS TRANSFERS -------------------------------------------------------
&nbsp;
        // REWARDS
&nbsp;
        emit RewardPaid(msg.sender, id, reward);
&nbsp;
        if (reward != 0) {
            rewardToken.safeTransfer(msg.sender, reward);
        }
&nbsp;
        // PRINCIPAL
&nbsp;
        stakingToken.safeTransfer(msg.sender, amount);
    }
&nbsp;
    /// @dev Allows user to claim earned rewards without unstaking the position
    /// @param id Stake id
    function claim(uint256 id) external onlyWhenErrorGuardDisabled {
        _updateReward(id, true);
        // CHANGE STATE &amp; EXECUTE ALL CHECKS
        uint256 reward = _claimInternal(id, msg.sender);
&nbsp;
        require(reward != 0, 'Nothing to claim');
&nbsp;
        // ALL TOKENS TRANSFERS -------------------------------------------------------
&nbsp;
        // REWARDS
&nbsp;
        emit RewardPaid(msg.sender, id, reward);
&nbsp;
        // reward != 0 due to technical design
        rewardToken.safeTransfer(msg.sender, reward);
    }
&nbsp;
    /// @dev Allows owner to set new reward rate
    /// @param newRewardRate is amount of token weis will be distributed per second (rewards / rewardsDuration)
    function notifyRewardAmount(uint128 newRewardRate) external onlyWhenErrorGuardDisabled onlyOwner {
        _updateReward(0, false);
        _notifyRewardAmount(newRewardRate);
    }
&nbsp;
    /// @dev Allows owner to set previous reward rate
    function notifyRewardAmountPrevious() external onlyWhenErrorGuardDisabled onlyOwner {
        _updateReward(0, false);
        uint128 rate = rewardRate;
        require(rate != 0, 'Previous reward rate is too low');
        _notifyRewardAmount(rate);
    }
&nbsp;
    /// @dev Allows owner to stop staking and extract extra liquidity
    /// @param recepient is the extra liquidity recepient
    function finish(address recepient) external onlyWhenErrorGuardDisabled onlyOwner {
        require(!finished, 'Finished');
        require(recepient != address(0), 'Zero recepient');
        uint256 periodFinishLocal = periodFinish;
        require(
            block.timestamp &gt; periodFinishLocal &amp;&amp; periodFinishLocal != 0,
            'Only after period end'
        );
&nbsp;
        // lastTimeRewardApplicable == periodFinish  (period is already over)
        uint256 previousPeriodRewardDuration = periodFinishLocal - periodStart;
&nbsp;
        // no need to unstake owner stake (no active reward period + all rewards are counted in getUnusedRewards())
&nbsp;
        // update cumulative variables
        // use REAL previous period rewards duration here
        uint256 currentRewardDistributed = rewardRate * previousPeriodRewardDuration;
&nbsp;
        cumulativeDistributedReward += currentRewardDistributed;
        cumulativeRewardPaid += currentRewardPaid;
        currentRewardPaid = 0;
&nbsp;
        uint256 unusedReward = getUnusedRewards();
&nbsp;
        uint256 unclaimedReward = cumulativeDistributedReward -
            cumulativeRewardPaid -
            unusedReward -
            unusedRewardsExtracted;
&nbsp;
        IERC20Upgradeable rewardTokenLocal = rewardToken;
        IERC20Upgradeable stakingTokenLocal = stakingToken;
&nbsp;
        uint256 rewardTokenBalance = rewardTokenLocal.balanceOf(address(this));
        uint256 stakingTokenBalance = stakingTokenLocal.balanceOf(address(this));
&nbsp;
        finished = true;
&nbsp;
        // unusedRewards - from contract
        // unclaimed rewards - on contract
&nbsp;
        emit Finished(recepient);
&nbsp;
        if (rewardTokenLocal == stakingTokenLocal) {
            uint256 supply = totalSupply();
&nbsp;
            if (rewardTokenBalance - (supply + unclaimedReward) != 0) {
                rewardTokenLocal.safeTransfer(
                    recepient,
                    rewardTokenBalance - (supply + unclaimedReward)
                );
            }
        } else {
            if (rewardTokenBalance - unclaimedReward != 0) {
                rewardTokenLocal.safeTransfer(
                    recepient,
                    rewardTokenBalance - unclaimedReward
                );
            }
&nbsp;
            uint256 supply = totalSupply();
            if (stakingTokenBalance - supply != 0) {
                stakingTokenLocal.safeTransfer(recepient, stakingTokenBalance - supply);
            }
        }
    }
&nbsp;
    /// @dev Allows owner to stop staking and extract extra liquidity
    /// @param recepient is the extra liquidity recepient
    function withdrawOtherTokens(address token, address recepient) external onlyWhenErrorGuardDisabled onlyOwner {
        require(token != address(0), 'Invalid token');
        require(recepient != address(0), 'Zero recepient');
        require(token != address(stakingToken), 'Token == staking token');
        require(token != address(rewardToken), 'Token == reward token');
&nbsp;
        uint256 balance = IERC20Upgradeable(token).balanceOf(address(this));
        require(balance != 0, 'Zero balance');
&nbsp;
        emit WithdrawnTokens(recepient, balance);
        IERC20Upgradeable(token).safeTransfer(recepient, balance);
    }
&nbsp;
    /// @dev Allows owner to set period of rewards distribution
    /// @param rewardsDuration_ is new rewardsDuration amount
    /// @notice Can be applied when error guard is enabled and when it is disabled
    function setRewardsDuration(uint64 rewardsDuration_) external onlyOwner {
        require(block.timestamp &gt; periodFinish, 'Previous period not complete');
        require(
            rewardsDuration_ &gt;= MIN_REWARDS_DURATION,
            'Rewards duration is too short'
        );
        require(rewardsDuration_ &lt;= MAX_REWARDS_DURATION, 'Rewards duration is too long');
        require(rewardsDuration_ != rewardsDuration, 'Rewards duration duplicate');
        rewardsDuration = rewardsDuration_;
        emit RewardsDurationUpdated(rewardsDuration_);
    }
&nbsp;
    /// @dev Sets paused state for the contract (can be called by the owner only)
    /// @param state paused flag
    function setPaused(bool state) external onlyOwner onlyWhenErrorGuardDisabled {
        if (state) {
            _pause();
        } else {
            _unpause();
        }
    }
&nbsp;
    // external view
&nbsp;
    /// @dev Allows to view staking amount of selected user
    /// @param account to view balance
    /// @return balance of staking tokens for selected account
    function balanceOf(address account) external view returns (uint256) {
        return userBalances[account];
    }
&nbsp;
    /// @dev Allows to view user`s stake ids quantity
    /// @param user user account
    /// @return length of user ids array
    function getUserStakeIdsLength(address user) external view returns (uint256) {
        return idsByUser[user].length();
    }
&nbsp;
    /// @dev Allows to view if a user has a stake with specific id
    /// @param user user account
    /// @param id stake id
    /// @return bool flag (true if a user has owns the id)
    function hasStakeId(address user, uint256 id) external view returns (bool) {
        return idsByUser[user].contains(id);
    }
&nbsp;
    /// @dev Allows to get a slice user stakes array
    /// @param user user account
    /// @param startIndex Starting index in user ids array
    /// @param length return array length
    /// @return Array-slice of user stakes
    function getUserStakesSlice(
        address user,
        uint256 startIndex,
        uint256 length
    ) external view returns (Stake[] memory) {
        require(length != 0, 'Zero length');
        require(
            startIndex + length &lt;= idsByUser[user].length(),
            'Invalid startIndex + length'
        );
        Stake[] memory userStakes = new Stake[](length);
        for (uint256 i; i &lt; length; ) {
            uint256 stakeId = idsByUser[user].at(i + startIndex);
            userStakes[i] = stakes[stakeId];
            userStakes[i].earned = earned(stakeId);
&nbsp;
            unchecked {
                ++i;
            }
        }
&nbsp;
        return userStakes;
    }
&nbsp;
    /// @dev Allows to get a slice user stakes history array
    /// @param user user account
    /// @param startIndex Starting index in user ids array
    /// @param length return array length
    /// @return Array-slice of user stakes history
    function getUserInactiveStakesSlice(
        address user,
        uint256 startIndex,
        uint256 length
    ) external view returns (Stake[] memory) {
        require(length != 0, 'Zero length');
        require(
            startIndex + length &lt;= userInactiveStakes[user].length,
            'Invalid startIndex + length'
        );
        Stake[] memory userStakes = new Stake[](length);
&nbsp;
        for (uint256 i; i &lt; length; ) {
            uint256 stakeId = userInactiveStakes[user][i + startIndex];
            userStakes[i] = stakes[stakeId];
&nbsp;
            unchecked {
                ++i;
            }
        }
        return userStakes;
    }
&nbsp;
    /// @dev Allows to view user`s closed stakes quantity
    /// @param user user account
    /// @return length of user closed stakes array
    function getUserInactiveStakesLength(address user) external view returns (uint256) {
        return userInactiveStakes[user].length;
    }
&nbsp;
    /// @dev Allows to view total cumulative unclaimed rewards (earned by all users)
    /// @return rewards (nominated in token weis)
    function getTotalRewards() external view returns (uint256) {
        if (totalSupply() != 0) {
            uint256 timePassed = lastTimeRewardApplicable() - periodStart;
&nbsp;
            uint256 totalDistributedRewards = cumulativeDistributedReward;
&nbsp;
            if (!finished) {
                totalDistributedRewards += rewardRate * timePassed;
            }
&nbsp;
            uint256 totalClaimedRewards = cumulativeRewardPaid + currentRewardPaid;
&nbsp;
            return
                totalDistributedRewards -
                totalClaimedRewards -
                getUnusedRewards() -
                unusedRewardsExtracted;
        } else {
            return 0;
        }
    }
&nbsp;
    /// @dev Returns the approximate APR for a specific stake position not including penalties
    /// @return APR value multiplied by 10**18
    function getPotentialAPR() external view returns (uint256) {
        uint256 _tvl = totalSupply();
&nbsp;
        if (_tvl == 0) return 0;
        // earned user value in tokens for one second including share (1e18 for accuracy)
        return (uint256(rewardRate) * ACCURACY * 365 days * 100) / (_tvl);
    }
&nbsp;
    /// @dev Allows to view the number of stake holders
    /// @return length of stake holders array
    function getHoldersLength() external view returns (uint256) {
        return holders.length();
    }
&nbsp;
    /// @dev Allows to get a slice of stake holders array
    /// @param startIndex Starting index in stake holders array
    /// @param length return array length
    /// @return Array-slice of stake holders
    function getHoldersSlice(
        uint256 startIndex,
        uint256 length
    ) external view returns (address[] memory) {
        require(length != 0, 'Zero length');
        require(startIndex + length &lt;= holders.length(), 'Invalid startIndex + length');
        address[] memory holdersArray = new address[](length);
        for (uint256 i = 0; i &lt; length; ) {
            holdersArray[i] = holders.at(i + startIndex);
            unchecked {
                ++i;
            }
        }
        return holdersArray;
    }
&nbsp;
    /// @notice Returns the number of currently active stakes
    /// @dev Excludes the number of owner`s active stakes
    /// @return numOfActiveStakesInternal - number of active stakes, made by users
    function numOfActiveStakes() external view returns (uint256) {
        return numOfActiveStakesInternal - idsByUser[address(this)].length();
    }
&nbsp;
    // public
&nbsp;
    /// @notice Returns the user`s stakes total supply
    /// @dev Excludes reward owner stake supply
    /// @return totalSupplyInternal - total amount of staked tokens (in weis)
    function totalSupply() public view returns (uint256) {
        return totalSupplyInternal - userBalances[address(this)];
    }
&nbsp;
    /// @dev Allows to view last action time in the contract
    /// @return timestamp of last action
    function lastTimeRewardApplicable() public view returns (uint64) {
        return block.timestamp &lt; periodFinish ? uint64(block.timestamp) : periodFinish;
    }
&nbsp;
    /// @dev Allows to view already distributed rewards
    /// @return rewardPerTokenStored for current moment
    function rewardPerToken() public view returns (uint256) {
        uint256 totalSupplyInternalLocal = totalSupplyInternal;
        // can be == 0 before the first owner stake in made
        if (totalSupplyInternalLocal == 0) {
            return rewardPerTokenStored;
        }
&nbsp;
        // can not overflow here, rewardRate * duration * ACCURACY &lt;= uint128_max * 10 ** 18 &lt;&lt; uint256 max
        return
            rewardPerTokenStored +
            (((lastTimeRewardApplicable() - lastUpdateTime) *
                uint256(rewardRate) *
                ACCURACY) / totalSupplyInternalLocal);
    }
&nbsp;
    /// @dev Allows to view current user earned rewards
    /// @param id to view rewards
    /// @return earnedAmount of rewards for selected user
    function earned(uint256 id) public view returns (uint256) {
        Stake storage _stake = stakes[id];
        if (_stake.unstakedAtBlockNumber == 0) {
            // ACTIVE STAKE =&gt; calculate amount + increase reward per token
            // can not overflow here, amount * (rewardRate * duration * ACCURACY / total supply)
&nbsp;
            uint256 amount = _stake.amount;
            uint256 rewardPerTokenLocal = rewardPerToken();
            uint256 rewardPerTokenPaid = _stake.userRewardPerTokenPaid;
            uint256 reward = uint256(
                (amount * (rewardPerTokenLocal - rewardPerTokenPaid)) /
                    ACCURACY +
                    _stake.earned
            );
&nbsp;
            return reward;
        }
&nbsp;
        // INACTIVE STAKE
        return 0;
    }
&nbsp;
    /// @notice Returns the amount of unused reward tokens
    /// @return reward tokens amount in weis
    function getUnusedRewards() public view returns (uint256) {
        // makes return amount always updated real time
        return earned(0) + currentPeriodUnusedRewardsSum;
    }
&nbsp;
    // private
&nbsp;
    /// @dev Allows to set reward rate
    /// @param newRewardRate is amount of token weis will be distributed per second (rewards / rewardsDuration)
    function _notifyRewardAmount(uint128 newRewardRate) private {
        require(!finished, 'Finished');
        require(newRewardRate &lt;= MAX_RATE, 'Reward rate too high');
&nbsp;
        // reward for the incoming period =&gt; use the new rewardsDuration
        uint64 rewardsDurationLocal = rewardsDuration;
        uint256 rewardRateOld = uint256(rewardRate);
        uint256 reward = uint256(newRewardRate) * uint256(rewardsDurationLocal);
        uint256 periodFinishOld = periodFinish;
&nbsp;
        bool restakeOwnerPosition = true;
        if (firstRewardPeriodStart == 0) {
            // open owner stake in the first reward period (stake 1 wei to to accumulate unused rewards)
            _stakeInternal(TREASURY_STAKE_AMOUNT, address(this));
&nbsp;
            firstRewardPeriodStart = uint128(block.timestamp);
            restakeOwnerPosition = false;
        }
&nbsp;
        // update cumulative variables
        // add rewards from teh previous period =&gt; use previous reward period start
        uint256 currentRewardDistributed = periodFinishOld == 0
            ? 0
            : rewardRateOld * (lastTimeRewardApplicable() - periodStart);
&nbsp;
        cumulativeDistributedReward += currentRewardDistributed;
        cumulativeRewardPaid += currentRewardPaid;
        currentRewardPaid = 0;
&nbsp;
        // update rate with the reward from the incoming period =&gt; use the updated rewards duration
        if (block.timestamp &gt;= periodFinishOld) {
            // can not overflow here (MAX Numerator = Const * uint128_max * uint64),
            // Const &lt; 100 &lt;= num of reward periods, min period = 1 year
            rewardRate = uint128((reward + rewardsRemaining) / rewardsDurationLocal);
            // can not overfow here =&gt; MAX value = uint64_max - 1
            rewardsRemaining = uint128(
                (reward + rewardsRemaining) % rewardsDurationLocal
            );
        } else {
            uint64 remaining = uint64(periodFinishOld) - uint64(block.timestamp);
            uint256 leftover = remaining * rewardRateOld + rewardsRemaining;
            // can not overflow here (MAX Numerator = Const * uint128_max * uint64),
            // Const &lt; 100 &lt;= num of reward periods, min period = 1 year
            rewardRate = uint128((reward + leftover) / rewardsDurationLocal);
            // can not overfow here =&gt; MAX value = uint64_max - 1
            rewardsRemaining = uint128((reward + leftover) % rewardsDurationLocal);
        }
&nbsp;
        uint256 rewardRateNew = rewardRate;
&nbsp;
        require(rewardRateNew != 0, 'Actual reward rate is too low');
&nbsp;
        // Ensure the provided reward amount is not more than the balance in the contract.
        // This keeps the reward rate in the right range, preventing overflows due to
        // very high values of rewardRate in the earned and rewardsPerToken functions;
        uint256 balance = address(rewardToken) == address(stakingToken)
            ? rewardToken.balanceOf(address(this)) - totalSupply()
            : rewardToken.balanceOf(address(this));
&nbsp;
        bool updateUnusedReward = (totalSupply() == 0);
        uint256 unusedReward = getUnusedRewards();
&nbsp;
        uint256 unclaimedReward = cumulativeDistributedReward -
            cumulativeRewardPaid -
            unusedReward -
            unusedRewardsExtracted;
&nbsp;
        // unusedRewards are transferred to the owner in each notify
        currentPeriodUnusedRewardsSum = 0;
        // increase total unused rewards extracted after each period
        unusedRewardsExtracted += unusedReward;
&nbsp;
        // if no active stakers were previously =&gt; unstake owner stake to stop accumulating unused rewards
        if (updateUnusedReward &amp;&amp; restakeOwnerPosition) {
            _updateReward(0, true);
            // no update for cumulative unused reward here (already called getUnusedRewards() before, using earned())
            _withdrawInternal(0, address(this));
        }
&nbsp;
        // Ensure the balance in the contract is more than the maximum reward + unclaimedRewards
        require(
            rewardRateNew * rewardsDurationLocal + unclaimedReward + unusedReward &lt;=
                balance,
            'Provided reward too high'
        );
&nbsp;
        lastUpdateTime = uint64(block.timestamp);
        periodFinish = uint64(block.timestamp) + rewardsDurationLocal;
        periodStart = uint64(block.timestamp);
&nbsp;
        if (updateUnusedReward &amp;&amp; restakeOwnerPosition) {
            _stakeInternal(TREASURY_STAKE_AMOUNT, address(this));
        }
&nbsp;
        if (unusedReward != 0)
            IERC20Upgradeable(rewardToken).safeTransfer(owner(), unusedReward);
&nbsp;
        emit RewardAdded(reward);
    }
&nbsp;
    /// @dev Internal function for staking tokens
    /// @param amount of token to stake
    function _stakeInternal(uint256 amount, address interractor) private {
        totalSupplyInternal += amount;
        ++numOfActiveStakesInternal;
&nbsp;
        uint256 newId;
        if (interractor != address(this)) {
            newId = ++globalId;
        }
        // else owner stake =&gt; newId = 0 (not to affect other stakes)
&nbsp;
        stakes[newId] = Stake({
            id: newId,
            amount: amount,
            earned: 0,
            claimed: 0,
            userRewardPerTokenPaid: rewardPerTokenStored,
            owner: interractor,
            timestamp: uint32(block.timestamp),
            unstakedAtBlockNumber: 0,
            unstakedAtBlockTimestamp: 0
        });
&nbsp;
        // add new holder if needed (address(this) should not be displayed in holders)
        if (userBalances[interractor] == 0 &amp;&amp; interractor != address(this))
            holders.add(interractor);
&nbsp;
        userBalances[interractor] += amount;
        idsByUser[interractor].add(newId);
    }
&nbsp;
    /// @dev Internal function for withdrawing staked tokens + claim earned rewards
    /// @param id Stake id
    /// @param interractor Address which is supposed to be the stake owner
    /// @return amount - principal token amount, reward - reward token amount
    function _withdrawInternal(
        uint256 id,
        address interractor
    ) private returns (uint256 amount, uint256 reward) {
        Stake storage _stake = stakes[id];
        amount = _stake.amount;
        require(_stake.unstakedAtBlockNumber == 0, 'Already unstaked');
        require(_stake.owner == interractor, 'Called not by stake owner');
&nbsp;
        totalSupplyInternal -= amount;
        userBalances[interractor] -= amount;
&nbsp;
        --numOfActiveStakesInternal;
&nbsp;
        // calculate the available rewards
        // increase the currentRewardPaid
        // earned = 0, increase claimed
        reward = _claimInternal(id, interractor);
&nbsp;
        // address(this) should not be displayed in holders
        if (userBalances[interractor] == 0 &amp;&amp; interractor != address(this))
            holders.remove(interractor);
&nbsp;
        idsByUser[interractor].remove(id);
&nbsp;
        if (interractor != address(this)) userInactiveStakes[interractor].push(id);
&nbsp;
        stakes[id].unstakedAtBlockNumber = uint32(block.number);
        stakes[id].unstakedAtBlockTimestamp = uint32(block.timestamp);
    }
&nbsp;
    function _claimInternal(
        uint256 id,
        address interractor
    ) private returns (uint256 reward) {
        Stake storage _stake = stakes[id];
        require(_stake.unstakedAtBlockNumber == 0, 'Already unstaked');
        require(_stake.owner == interractor, 'Called not by stake owner');
&nbsp;
        // reward already updated
        reward = _stake.earned;
&nbsp;
        if (reward != 0 &amp;&amp; interractor != address(this)) {
            // CLAIM ALL EARNED REWARDS
            // update var only if claim by real user
            currentRewardPaid += reward;
        }
&nbsp;
        if (reward != 0) {
            stakes[id].earned = 0;
            stakes[id].claimed += reward;
        }
    }
&nbsp;
    /// @dev Update rewards pool information to correct rewards calculation for global varialbes and current stake
    /// @param id stake to update info for
    /// @param updateId flag, true when update stake struct
    function _updateReward(uint256 id, bool updateId) private {
        rewardPerTokenStored = rewardPerToken();
        lastUpdateTime = lastTimeRewardApplicable();
&nbsp;
        if (updateId) {
            stakes[id].earned = earned(id);
            stakes[id].userRewardPerTokenPaid = rewardPerTokenStored;
        }
    }
}
&nbsp;</pre></td></tr>
</table></pre>
<div class='push'></div><!-- for sticky footer -->
</div><!-- /wrapper -->
<div class='footer quiet pad2 space-top1 center small'>
  Code coverage
  generated by <a href="http://istanbul-js.org/" target="_blank">istanbul</a> at Thu Jun 13 2024 17:58:54 GMT+0300 (Moscow Standard Time)
</div>
</div>
<script src="../prettify.js"></script>
<script>
window.onload = function () {
        if (typeof prettyPrint === 'function') {
            prettyPrint();
        }
};
</script>
<script src="../sorter.js"></script>
</body>
</html>
